mod Mxgrf logic: 'cl'

incl Mtex

incl Mtexgr

incl Maux

rem 
  \para \bf  Recursive Indices.  \end 

rem 
  \para \bf  Arithmetization of recursive terms.  \end 

fun Vt 'Tex_f1_gr_vt'
  Vt(i) = 0,i

fun/0 Zt 'Tex_f0_gr_zt'
  Zt = 1,0

fun St 'Tex_f1_gr_st'
  St(t) = 2,t

fun Pt 'Tex_f1_gr_pt'
  Pt(t) = 3,t

fun/3 Dt 'Tex_f3_gr_dt'
  Dt(t1,t2,t3) = 4,t1,t2,t3

fun/2 Act 'Tex_f2_gr_act'
  Act(t1,t2) = 5,t1,t2

fun/2 Apt 'Tex_f2_gr_apt'
  Apt(e,ts) = 6,e,ts

rem 
  \para \bf  Arithmetization of recursive function symbols.  \end 

fun Fs 'Tex_f2_gr_fs'
  Fs(n) = 7,n

fun/2 Ls 'Tex_f2_gr_ls'
  Ls(n,t) = 8,n,t

rem 
  \para \bf  Codes of numerals.  \end 

pred Nm 
  Nm(Zt)
  Nm St(t) <- Nm(t)

pred Nms 
  Nms(0)
  Nms(t,ts) <- Nm(t) & Nms(ts)

rem 
  \para \bf  Auxiliary predicate.  \end 
  \eq* 
    Is_apt(t) <-> \e e\e ts t = Apt(e,ts)
  \end

pred Is_apt 
  Is_apt Apt(e,ts)

rem 
  \para \bf  Contraction function.  \end 
  \header* fun/2 Cntr 'Tex_f2_gr_cntr' \end 
  \eq* 
    Nm(t2) -> Cntr(Apt(e,ts),t2) = Apt(e,ts++(t2,0))
  \end
  \eq* 
    ~\e e\e ts(t1 = Apt(e,ts) & Nm(t2)) -> Cntr(t1,t2) = Act(t1,t2)
  \end

fun/2 Cntr 'Tex_f2_gr_cntr'
  Cntr(t1,t2) = Apt(e,ts++(t2,0)) <- Is_apt(t1) & Nm(t2) & t1 = Apt(e,ts)
  Cntr(t1,t2) = Act(t1,t2) <- Is_apt(t1) & ~Nm(t2)
  Cntr(t1,t2) = Act(t1,t2) <- ~Is_apt(t1)

rem 
  \para \bf  Closed recursive terms.  \end The predicate \ft Ctm(t) \end holds 
  if the number \ft t \end is the code of a closed recursive term. 

pred/3 Tm 
  Tm(n,Vt(i),0) <- 1 <= i & i <= n
  Tm(n,Zt,0)
  Tm(n,St(t),0) <- Tm(n,t,0)
  Tm(n,Pt(t),0) <- Tm(n,t,0)
  Tm(n,Dt(t1,t2,t3),0) <- Tm(n,t1,0) & Tm(n,t2,0) & Tm(n,t3,0)
  Tm(n,Act(t1,t2),rs) <- Tm(n,t1,t2,rs) & Tm(n,t2,0) & Is_apt(t1) & ~Nm(t2)
  Tm(n,Act(t1,t2),rs) <- Tm(n,t1,t2,rs) & Tm(n,t2,0) & ~Is_apt(t1)
  Tm(n,Apt(Fs(m),ts),rs) <- m = n & Nms(ts) & L(ts)+L(rs) = m
  Tm(n,Apt(Ls(m,t),ts),rs) <- m >= 1 & Nms(ts) & L(ts)+L(rs) = m & Tm(m,t,0)

pred Ctm 
  Ctm(t) <-> Tm(0,t,0)

rem 
  \para \bf  Well-formed recursive indices.  \end \header* pred/2 Rf  \end The 
  binary predicate \ft Rf(n,e) \end holds if the number \ft e \end is the code 
  of some \ft n \end-ary defined recursive function symbol. We say that the 
  number \ft e \end is a \it  well-formed recursive index  \end. 

pred/2 Rf 
  Rf(n,Ls(n1,t)) <- n >= 1 & n1 = n & Tm(n,t,0)

rem 
  \para \bf  [CL] Formats.  \end The predicate \ft Fr \end is the union format 
  and it can be used to control the display of the codes of recursive terms and 
  recursive function symbols in queries. 

pred Fr 
  Fr Vt(i) <- N(i)
  Fr(Zt)
  Fr St(t) <- Fr(t)
  Fr Pt(t) <- Fr(t)
  Fr Dt(t1,t2,t3) <- Fr(t1) & Fr(t2) & Fr(t3)
  Fr Act(t1,t2) <- Fr(t1) & Fr(t2)
  Fr Apt(e,ts) <- Fr(e) & Nms(ts)
  Fr Fs(n) <- N(n)
  Fr Ls(n,t) <- N(n) & Fr(t)

